.586
.model flat, stdcall
option casemap:none
include windows.inc
include kernel32.inc
includelib kernel32.lib
include user32.inc
includelib user32.lib
include gdi32.inc
includelib gdi32.lib

;***************************************************************************************************

WinMain proto
WndProc proto hwnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

;***************************************************************************************************

WIN_WIDTH       equ 680
WIN_HEIGHT      equ 350

;***************************************************************************************************

.const
ClassName   db "WinClass",0
AppName     db "AppName",0
FontName    db "MusicalSymbols",0
PointSize   DWORD 36
string1     db "abcdefghijklmnopqrstuvwxyz"
string2     db "ABCDEFGHIJKLMNOPQRSTUVWXYZ"
string3     db "!""#$%&'()*+,-./"

.data?
hInstance   HINSTANCE   ?
hWnd        HWND        ?
hFont       HANDLE      ?
lf          LOGFONT     <?>

.code
start:
    invoke GetModuleHandle, NULL
    mov hInstance,eax
    invoke WinMain
    invoke ExitProcess, eax

;***************************************************************************************************

WinMain proc
    LOCAL wc:WNDCLASSEX
    LOCAL msg:MSG
    mov [wc].cbSize,SIZEOF wc
    mov [wc].style,CS_HREDRAW or CS_VREDRAW
    mov [wc].lpfnWndProc,OFFSET WndProc
    mov eax,hInstance
    mov [wc].hInstance,eax
    invoke LoadIcon, NULL,IDI_APPLICATION
    mov [wc].hIcon,eax
    invoke LoadCursor, NULL,IDC_ARROW
    mov [wc].hCursor,eax
    mov [wc].hbrBackground,COLOR_WINDOW+1
    mov [wc].lpszClassName,OFFSET ClassName
    xor eax,eax
    mov [wc].cbClsExtra,eax
    mov [wc].cbWndExtra,eax
    mov [wc].lpszMenuName,eax
    mov [wc].hIconSm,eax
    invoke RegisterClassEx, ADDR wc
    invoke CreateWindowEx, NULL,ADDR ClassName,ADDR AppName,WS_OVERLAPPEDWINDOW,CW_USEDEFAULT,CW_USEDEFAULT,WIN_WIDTH,WIN_HEIGHT,NULL,NULL,hInstance,NULL
    .IF (eax)
        push ebx
        mov hWnd,eax
        invoke ShowWindow, hWnd,SW_SHOWDEFAULT
        invoke UpdateWindow, hWnd
        lea ebx,[msg]
        assume ebx:ptr MSG
        .WHILE TRUE
            xor eax,eax
            invoke GetMessage, ebx,eax,eax,eax
            .BREAK .IF(!eax)
            invoke TranslateMessage, ebx
            invoke DispatchMessage, ebx
        .ENDW
        mov eax,[ebx].wParam
        assume ebx:nothing
        pop ebx
    .ENDIF
    ret
WinMain endp

WndProc proc hwnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
    LOCAL hDC:HDC
    LOCAL ps:PAINTSTRUCT
    mov eax,uMsg
;-- WM_PAINT ---------------------------------------------------------------------------------------
    .IF (eax==WM_PAINT)
        invoke BeginPaint, hwnd,ADDR ps
        mov hDC,eax

        invoke SelectObject, hDC,hFont
        invoke TextOut, hDC,5,0,ADDR string1,SIZEOF string1
        invoke TextOut, hDC,5,100,ADDR string2,SIZEOF string2
        invoke TextOut, hDC,5,200,ADDR string3,SIZEOF string3
        pop ebx

        invoke EndPaint, hwnd,ADDR ps
;-- WM_CREATE --------------------------------------------------------------------------------------
    .ELSEIF (eax==WM_CREATE)
        push edi
        push ebx
        mov edi,OFFSET lf
        assume edi:ptr LOGFONT
        invoke GetDC, hwnd
        mov ebx,eax
        invoke GetDeviceCaps, ebx,LOGPIXELSY
        mul PointSize
        mov ecx,72
        div ecx
        neg eax
        mov [edi].lfHeight,eax
        invoke ReleaseDC, hwnd,ebx
        xor ecx,ecx
        mov [edi].lfWidth,ecx
        mov [edi].lfEscapement,ecx
        mov [edi].lfOrientation,ecx
        mov [edi].lfWeight,FW_NORMAL
        mov [edi].lfItalic,cl
        mov [edi].lfUnderline,cl
        mov [edi].lfStrikeOut,cl
        mov [edi].lfCharSet,DEFAULT_CHARSET
        mov [edi].lfOutPrecision,OUT_DEFAULT_PRECIS
        mov [edi].lfClipPrecision,CLIP_DEFAULT_PRECIS
        mov [edi].lfQuality,DEFAULT_QUALITY
        mov [edi].lfPitchAndFamily,DEFAULT_PITCH or FF_DECORATIVE
        invoke lstrcpyn, ADDR [edi].lfFaceName,ADDR FontName,SIZEOF lf.lfFaceName

        invoke CreateFontIndirect, edi
        mov hFont,eax

        assume edi:nothing
        pop ebx
        pop edi
;-- WM_DESTROY -------------------------------------------------------------------------------------
    .ELSEIF (eax==WM_DESTROY)
        invoke DeleteObject, hFont
        invoke PostQuitMessage, NULL
;-- default ----------------------------------------------------------------------------------------
    .ELSE
        invoke DefWindowProc, hwnd,uMsg,wParam,lParam
        ret
    .ENDIF
    xor eax,eax
    ret
WndProc endp

end start
